package dev.fitko.fitconnect.client.steps.sender;

import dev.fitko.fitconnect.api.domain.model.destination.Destination;

import java.util.Optional;
import java.util.UUID;

public interface StartStep {

    /**
     * Creates new submission request.
     *
     * @return next step to add (optional) attachments
     */
    AttachmentsStep newSubmission();

    /**
     * Creates new submission request wit already encrypted data.
     *
     * @return next step to add (optional) attachments
     */
    EncryptedAttachmentsStep newSubmissionWithEncryptedData();

    /**
     * Retrieve the public encryption key
     *
     * @param destinationId unique identifier of a {@link Destination}
     * @return optional string containing the public JWK
     */
    Optional<String> getPublicKey(UUID destinationId);
}
